/* A Bison parser, made by GNU Bison 2.6.4.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.6.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         smtlibparse
#define yylex           smtliblex
#define yyerror         smtliberror
#define yylval          smtliblval
#define yychar          smtlibchar
#define yydebug         smtlibdebug
#define yynerrs         smtlibnerrs

/* Copy the first part of user declarations.  */
/* Line 358 of yacc.c  */
#line 1 "smtlib.y"

/*****************************************************************************/
/*!
 * \file smtlib.y
 * 
 * Author: Clark Barrett
 * 
 * Created: Apr 30 2005
 *
 * <hr>
 *
 * License to use, copy, modify, sell and/or distribute this software
 * and its documentation for any purpose is hereby granted without
 * royalty, subject to the terms and conditions defined in the \ref
 * LICENSE file provided with this distribution.
 * 
 * <hr>
 * 
 */
/*****************************************************************************/
/* 
   This file contains the bison code for the parser that reads in CVC
   commands in SMT-LIB language.
*/

#include "vc.h"
#include "parser_exception.h"
#include "parser_temp.h"
#include "translator.h"
#include "theory_arith.h"
#include "command_line_flags.h"
#include <string>

// Exported shared data
namespace CVC3 {
  extern ParserTemp* parserTemp;
}
// Define shortcuts for various things
#define TMP CVC3::parserTemp
#define EXPR CVC3::parserTemp->expr
#define VC (CVC3::parserTemp->vc)
#define ARRAYSENABLED (CVC3::parserTemp->arrFlag)
#define BVENABLED (CVC3::parserTemp->bvFlag)
#define BVSIZE (CVC3::parserTemp->bvSize)
#define RAT(args) CVC3::newRational args
#define QUERYPARSED CVC3::parserTemp->queryParsed
#define TRANSLATOR CVC3::parserTemp->translator

// Suppress the bogus warning suppression in bison (it generates
// compile error)
#undef __GNUC_MINOR__

/* stuff that lives in smtlib.lex */
extern int smtliblex(void);

int smtliberror(const char *s)
{
  std::ostringstream ss;
  ss << CVC3::parserTemp->fileName << ":" << CVC3::parserTemp->lineNum
     << ": " << s;
  return CVC3::parserTemp->error(ss.str());
}



#define YYLTYPE_IS_TRIVIAL 1
#define YYMAXDEPTH 10485760


/* Line 358 of yacc.c  */
#line 145 "parsesmtlib.cpp"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parsesmtlib.hpp".  */
#ifndef YY_SMTLIB_PARSESMTLIB_HPP_INCLUDED
# define YY_SMTLIB_PARSESMTLIB_HPP_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int smtlibdebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUMERAL_TOK = 258,
     SYM_TOK = 259,
     ID_TOK = 260,
     STRING_TOK = 261,
     AR_SYMB = 262,
     USER_VAL_TOK = 263,
     COMMENT_TOK = 264,
     TRUE_TOK = 265,
     FALSE_TOK = 266,
     ITE_TOK = 267,
     NOT_TOK = 268,
     IMPLIES_TOK = 269,
     IF_THEN_ELSE_TOK = 270,
     AND_TOK = 271,
     OR_TOK = 272,
     XOR_TOK = 273,
     IFF_TOK = 274,
     EXISTS_TOK = 275,
     FORALL_TOK = 276,
     LET_TOK = 277,
     FLET_TOK = 278,
     NOTES_TOK = 279,
     CVC_COMMAND_TOK = 280,
     LOGIC_TOK = 281,
     COLON_TOK = 282,
     LBRACKET_TOK = 283,
     RBRACKET_TOK = 284,
     LCURBRACK_TOK = 285,
     RCURBRACK_TOK = 286,
     LPAREN_TOK = 287,
     RPAREN_TOK = 288,
     SAT_TOK = 289,
     UNSAT_TOK = 290,
     UNKNOWN_TOK = 291,
     ASSUMPTION_TOK = 292,
     FORMULA_TOK = 293,
     STATUS_TOK = 294,
     BENCHMARK_TOK = 295,
     SOURCE_TOK = 296,
     CATEGORY_TOK = 297,
     EXTRASORTS_TOK = 298,
     EXTRAFUNS_TOK = 299,
     EXTRAPREDS_TOK = 300,
     DOLLAR_TOK = 301,
     QUESTION_TOK = 302,
     DISTINCT_TOK = 303,
     EOF_TOK = 304,
     PAT_TOK = 305
   };
#endif
/* Tokens.  */
#define NUMERAL_TOK 258
#define SYM_TOK 259
#define ID_TOK 260
#define STRING_TOK 261
#define AR_SYMB 262
#define USER_VAL_TOK 263
#define COMMENT_TOK 264
#define TRUE_TOK 265
#define FALSE_TOK 266
#define ITE_TOK 267
#define NOT_TOK 268
#define IMPLIES_TOK 269
#define IF_THEN_ELSE_TOK 270
#define AND_TOK 271
#define OR_TOK 272
#define XOR_TOK 273
#define IFF_TOK 274
#define EXISTS_TOK 275
#define FORALL_TOK 276
#define LET_TOK 277
#define FLET_TOK 278
#define NOTES_TOK 279
#define CVC_COMMAND_TOK 280
#define LOGIC_TOK 281
#define COLON_TOK 282
#define LBRACKET_TOK 283
#define RBRACKET_TOK 284
#define LCURBRACK_TOK 285
#define RCURBRACK_TOK 286
#define LPAREN_TOK 287
#define RPAREN_TOK 288
#define SAT_TOK 289
#define UNSAT_TOK 290
#define UNKNOWN_TOK 291
#define ASSUMPTION_TOK 292
#define FORMULA_TOK 293
#define STATUS_TOK 294
#define BENCHMARK_TOK 295
#define SOURCE_TOK 296
#define CATEGORY_TOK 297
#define EXTRASORTS_TOK 298
#define EXTRAFUNS_TOK 299
#define EXTRAPREDS_TOK 300
#define DOLLAR_TOK 301
#define QUESTION_TOK 302
#define DISTINCT_TOK 303
#define EOF_TOK 304
#define PAT_TOK 305



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 374 of yacc.c  */
#line 71 "smtlib.y"

  std::string *str;
  std::vector<std::string> *strvec;
  CVC3::Expr *node;
  std::vector<CVC3::Expr> *vec;
  std::pair<std::vector<CVC3::Expr>, std::vector<CVC3::Expr> > *pat_ann;


/* Line 374 of yacc.c  */
#line 297 "parsesmtlib.cpp"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE smtliblval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int smtlibparse (void *YYPARSE_PARAM);
#else
int smtlibparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int smtlibparse (void);
#else
int smtlibparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_SMTLIB_PARSESMTLIB_HPP_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 377 of yacc.c  */
#line 325 "parsesmtlib.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   376

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  51
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  40
/* YYNRULES -- Number of rules.  */
#define YYNRULES  126
/* YYNRULES -- Number of states.  */
#define YYNSTATES  261

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   305

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,    11,    13,    15,    17,    19,    22,
      26,    30,    34,    38,    42,    46,    52,    58,    64,    68,
      72,    74,    79,    81,    83,    85,    87,    89,    92,    94,
      97,   102,   106,   109,   111,   114,   119,   123,   126,   128,
     130,   133,   135,   141,   146,   153,   159,   169,   178,   188,
     197,   199,   201,   204,   207,   212,   214,   217,   222,   224,
     226,   228,   230,   232,   234,   236,   238,   240,   242,   247,
     253,   258,   264,   269,   271,   273,   275,   277,   279,   282,
     284,   289,   295,   300,   308,   315,   325,   334,   344,   353,
     355,   357,   359,   362,   364,   367,   369,   374,   381,   383,
     385,   387,   392,   399,   401,   403,   405,   408,   411,   414,
     416,   419,   421,   423,   425,   434,   442,   448,   453,   463,
     472,   482,   491,   496,   503,   505,   507
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      52,     0,    -1,    53,    -1,    32,    40,    54,    55,    33,
      -1,    49,    -1,     4,    -1,     5,    -1,    56,    -1,    55,
      56,    -1,    27,    37,    67,    -1,    27,    38,    67,    -1,
      27,    39,    58,    -1,    27,    41,     8,    -1,    27,    42,
       8,    -1,    27,    26,    57,    -1,    27,    43,    32,    59,
      33,    -1,    27,    44,    32,    60,    33,    -1,    27,    45,
      32,    63,    33,    -1,    27,    24,     6,    -1,    27,    25,
       6,    -1,    80,    -1,     4,    28,     3,    29,    -1,     4,
      -1,    34,    -1,    35,    -1,    36,    -1,    82,    -1,    59,
      82,    -1,    61,    -1,    60,    61,    -1,    32,    62,    79,
      33,    -1,    32,    62,    33,    -1,    84,    59,    -1,    64,
      -1,    63,    64,    -1,    32,    65,    79,    33,    -1,    32,
      65,    33,    -1,    83,    59,    -1,    83,    -1,    67,    -1,
      66,    67,    -1,    74,    -1,    32,    73,    66,    79,    33,
      -1,    32,    73,    66,    33,    -1,    32,    72,    70,    67,
      68,    33,    -1,    32,    72,    70,    67,    33,    -1,    32,
      22,    32,    86,    77,    33,    67,    79,    33,    -1,    32,
      22,    32,    86,    77,    33,    67,    33,    -1,    32,    23,
      32,    87,    67,    33,    67,    79,    33,    -1,    32,    23,
      32,    87,    67,    33,    67,    33,    -1,    69,    -1,    80,
      -1,    68,    69,    -1,    68,    80,    -1,    50,    30,    88,
      31,    -1,    71,    -1,    70,    71,    -1,    32,    86,    82,
      33,    -1,    20,    -1,    21,    -1,    13,    -1,    14,    -1,
      15,    -1,    16,    -1,    17,    -1,    18,    -1,    19,    -1,
      75,    -1,    32,    75,    79,    33,    -1,    32,    83,    76,
      79,    33,    -1,    32,    83,    76,    33,    -1,    32,    48,
      76,    79,    33,    -1,    32,    48,    76,    33,    -1,    10,
      -1,    11,    -1,    87,    -1,    83,    -1,    77,    -1,    76,
      77,    -1,    78,    -1,    32,    78,    79,    33,    -1,    32,
      84,    76,    79,    33,    -1,    32,    84,    76,    33,    -1,
      32,    12,    67,    77,    77,    79,    33,    -1,    32,    12,
      67,    77,    77,    33,    -1,    32,    22,    32,    86,    77,
      33,    77,    79,    33,    -1,    32,    22,    32,    86,    77,
      33,    77,    33,    -1,    32,    23,    32,    87,    67,    33,
      77,    79,    33,    -1,    32,    23,    32,    87,    67,    33,
      77,    33,    -1,    86,    -1,    84,    -1,    80,    -1,    79,
      80,    -1,    85,    -1,    85,    81,    -1,     8,    -1,     4,
      28,     3,    29,    -1,     4,    28,     3,    27,     3,    29,
      -1,     4,    -1,     4,    -1,     7,    -1,     4,    28,     3,
      29,    -1,     4,    28,     3,    27,     3,    29,    -1,     4,
      -1,     7,    -1,     3,    -1,    27,     4,    -1,    47,     4,
      -1,    46,     4,    -1,    89,    -1,    88,    89,    -1,    86,
      -1,    87,    -1,    90,    -1,    32,    13,    32,    90,    76,
      79,    33,    33,    -1,    32,    13,    32,    90,    76,    33,
      33,    -1,    32,    90,    76,    79,    33,    -1,    32,    90,
      76,    33,    -1,    32,    22,    32,    86,    77,    33,    89,
      79,    33,    -1,    32,    22,    32,    86,    77,    33,    89,
      33,    -1,    32,    23,    32,    87,    67,    33,    89,    79,
      33,    -1,    32,    23,    32,    87,    67,    33,    89,    33,
      -1,     4,    28,     3,    29,    -1,     4,    28,     3,    27,
       3,    29,    -1,     4,    -1,     7,    -1,     3,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   148,   148,   157,   164,   172,   178,   187,   195,   206,
     211,   217,   221,   227,   233,   329,   334,   339,   344,   350,
     355,   363,   369,   376,   377,   378,   382,   388,   397,   404,
     413,   418,   425,   440,   447,   456,   461,   468,   477,   486,
     493,   502,   506,   513,   519,   527,   534,   543,   551,   560,
     571,   577,   583,   589,   597,   604,   610,   619,   628,   632,
     639,   643,   647,   651,   655,   659,   663,   670,   674,   679,
     696,   705,   723,   738,   742,   746,   750,   757,   763,   772,
     776,   781,   789,   796,   804,   811,   820,   828,   837,   848,
     852,   865,   871,   881,   886,   895,   903,   914,   928,   942,
     976,   999,  1035,  1048,  1197,  1223,  1236,  1243,  1251,  1259,
    1266,  1275,  1279,  1283,  1293,  1302,  1310,  1318,  1325,  1334,
    1342,  1351,  1362,  1398,  1411,  1589,  1615
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUMERAL_TOK", "SYM_TOK", "ID_TOK",
  "STRING_TOK", "AR_SYMB", "USER_VAL_TOK", "COMMENT_TOK", "TRUE_TOK",
  "FALSE_TOK", "ITE_TOK", "NOT_TOK", "IMPLIES_TOK", "IF_THEN_ELSE_TOK",
  "AND_TOK", "OR_TOK", "XOR_TOK", "IFF_TOK", "EXISTS_TOK", "FORALL_TOK",
  "LET_TOK", "FLET_TOK", "NOTES_TOK", "CVC_COMMAND_TOK", "LOGIC_TOK",
  "COLON_TOK", "LBRACKET_TOK", "RBRACKET_TOK", "LCURBRACK_TOK",
  "RCURBRACK_TOK", "LPAREN_TOK", "RPAREN_TOK", "SAT_TOK", "UNSAT_TOK",
  "UNKNOWN_TOK", "ASSUMPTION_TOK", "FORMULA_TOK", "STATUS_TOK",
  "BENCHMARK_TOK", "SOURCE_TOK", "CATEGORY_TOK", "EXTRASORTS_TOK",
  "EXTRAFUNS_TOK", "EXTRAPREDS_TOK", "DOLLAR_TOK", "QUESTION_TOK",
  "DISTINCT_TOK", "EOF_TOK", "PAT_TOK", "$accept", "cmd", "benchmark",
  "bench_name", "bench_attributes", "bench_attribute", "logic_name",
  "status", "sort_symbs", "fun_symb_decls", "fun_symb_decl", "fun_sig",
  "pred_symb_decls", "pred_symb_decl", "pred_sig", "an_formulas",
  "an_formula", "patterns_annotations", "pattern", "quant_vars",
  "quant_var", "quant_symb", "connective", "an_atom", "prop_atom",
  "an_terms", "an_term", "basic_term", "annotations", "annotation",
  "user_value", "sort_symb", "pred_symb", "fun_symb", "attribute", "var",
  "fvar", "an_exprs", "an_expr", "fun_pred_symb", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    51,    52,    53,    53,    54,    54,    55,    55,    56,
      56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
      56,    57,    57,    58,    58,    58,    59,    59,    60,    60,
      61,    61,    62,    63,    63,    64,    64,    65,    65,    66,
      66,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      68,    68,    68,    68,    69,    70,    70,    71,    72,    72,
      73,    73,    73,    73,    73,    73,    73,    74,    74,    74,
      74,    74,    74,    75,    75,    75,    75,    76,    76,    77,
      77,    77,    77,    77,    77,    77,    77,    77,    77,    78,
      78,    79,    79,    80,    80,    81,    82,    82,    82,    83,
      83,    84,    84,    84,    84,    84,    85,    86,    87,    88,
      88,    89,    89,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    90,    90,    90,    90,    90
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     5,     1,     1,     1,     1,     2,     3,
       3,     3,     3,     3,     3,     5,     5,     5,     3,     3,
       1,     4,     1,     1,     1,     1,     1,     2,     1,     2,
       4,     3,     2,     1,     2,     4,     3,     2,     1,     1,
       2,     1,     5,     4,     6,     5,     9,     8,     9,     8,
       1,     1,     2,     2,     4,     1,     2,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     5,
       4,     5,     4,     1,     1,     1,     1,     1,     2,     1,
       4,     5,     4,     7,     6,     9,     8,     9,     8,     1,
       1,     1,     2,     1,     2,     1,     4,     6,     1,     1,
       1,     4,     6,     1,     1,     1,     2,     2,     2,     1,
       2,     1,     1,     1,     8,     7,     5,     4,     9,     8,
       9,     8,     4,     6,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     4,     0,     2,     0,     1,     5,     6,     0,
       0,     0,     7,    20,    93,   106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     3,     8,    95,
      94,    18,    19,    22,    14,    99,   100,    73,    74,     0,
       0,     9,    41,    67,    76,    75,    10,    23,    24,    25,
      11,    12,    13,     0,     0,     0,     0,    60,    61,    62,
      63,    64,    65,    66,    58,    59,     0,     0,     0,     0,
       0,     0,    76,   108,    98,     0,    26,     0,     0,    28,
       0,     0,    33,     0,     0,     0,   105,   103,   104,     0,
       0,     0,    77,    79,    90,    89,     0,     0,    55,     0,
      39,     0,     0,    91,     0,     0,    15,    27,     0,     0,
      16,    29,     0,    38,    17,    34,    21,     0,     0,     0,
       0,     0,     0,     0,    90,   107,    72,    78,     0,     0,
       0,     0,    56,    43,    40,     0,    68,    92,    70,     0,
       0,    31,     0,    32,    36,     0,    37,     0,     0,     0,
       0,     0,     0,     0,     0,    71,     0,    45,     0,     0,
      50,    51,    42,    69,     0,    96,    30,    35,     0,     0,
       0,   101,     0,     0,     0,    80,    82,     0,    57,     0,
      44,    52,    53,     0,     0,     0,     0,     0,     0,     0,
      81,   126,   124,   125,     0,   111,   112,     0,   109,   113,
      97,    47,     0,    49,     0,   102,    84,     0,     0,     0,
       0,     0,     0,     0,     0,    54,   110,    46,    48,    83,
       0,     0,     0,     0,     0,     0,     0,    86,     0,    88,
       0,     0,   122,     0,     0,     0,   117,     0,    85,    87,
       0,     0,     0,     0,   116,   123,     0,     0,     0,     0,
     115,     0,     0,     0,   114,   119,     0,   121,     0,   118,
     120
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     3,     4,     9,    11,    12,    34,    50,    75,    78,
      79,   108,    81,    82,   112,    99,    41,   159,   160,    97,
      98,    69,    70,    42,    43,    91,    92,    93,   102,   103,
      30,    76,    44,    94,    14,    95,    45,   197,   198,   199
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -187
static const yytype_int16 yypact[] =
{
     -13,   -31,  -187,    40,  -187,    83,  -187,  -187,  -187,    22,
     314,    15,  -187,  -187,    76,  -187,    86,   100,   111,    79,
      79,   309,   126,   139,    88,    92,   135,  -187,  -187,  -187,
    -187,  -187,  -187,   171,  -187,  -187,  -187,  -187,  -187,    10,
     179,  -187,  -187,  -187,  -187,  -187,  -187,  -187,  -187,  -187,
    -187,  -187,  -187,   205,   221,   233,   209,  -187,  -187,  -187,
    -187,  -187,  -187,  -187,  -187,  -187,   250,   251,    47,   253,
      79,   195,    47,  -187,   211,     1,  -187,   321,   143,  -187,
      34,   235,  -187,   196,   185,   248,  -187,   265,  -187,   109,
     292,   155,  -187,  -187,  -187,  -187,   185,   304,  -187,   204,
    -187,   296,    42,  -187,   197,   299,  -187,  -187,    44,   205,
    -187,  -187,    58,   205,  -187,  -187,  -187,    47,    79,   300,
      79,   277,   278,   195,    47,  -187,  -187,  -187,    75,   205,
     241,   -15,  -187,  -187,  -187,    77,  -187,  -187,  -187,    90,
      33,  -187,   102,   205,  -187,   112,   205,   283,   284,    70,
      47,   185,   248,   115,   239,  -187,   294,  -187,   301,   -11,
    -187,  -187,  -187,  -187,   334,  -187,  -187,  -187,    79,    79,
     343,  -187,    47,    47,    79,  -187,  -187,   116,  -187,   288,
    -187,  -187,  -187,   318,   127,   128,   320,   144,   315,   327,
    -187,  -187,   333,  -187,   319,  -187,  -187,   266,  -187,  -187,
    -187,  -187,   151,  -187,   153,  -187,  -187,   158,    47,    47,
     351,   330,   331,   332,    47,  -187,  -187,  -187,  -187,  -187,
     170,   180,   163,   326,   185,   248,   272,  -187,   183,  -187,
     190,   362,  -187,    47,    47,    79,  -187,   193,  -187,  -187,
     337,   274,   335,   336,  -187,  -187,   338,   200,   288,   288,
    -187,   339,   207,   208,  -187,  -187,   247,  -187,   257,  -187,
    -187
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -187,  -187,  -187,  -187,  -187,   356,  -187,  -187,   -39,  -187,
     295,  -187,  -187,   289,  -187,  -187,   -17,  -187,   215,  -187,
     279,  -187,  -187,  -187,   -32,   -61,   -45,   286,   -47,    -9,
    -187,   -65,   -35,   -34,  -187,   -83,   -79,  -187,  -182,  -186
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
      13,   117,    13,    46,    72,    74,   118,    71,   214,     5,
     107,   104,   101,   129,    35,   216,   101,    36,   157,     1,
      37,    38,   180,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,   106,   158,     2,   233,    35,   158,
       6,    36,    10,   109,   128,   113,   127,   129,    27,    10,
      86,    87,   135,   100,    88,   124,    40,   139,    68,   127,
     164,   142,   165,   154,   156,   145,   252,   253,   173,   101,
     143,   101,   147,   174,   146,   136,   153,   141,   107,    89,
     131,   107,   134,    35,    29,   101,    36,     7,     8,    37,
      38,   144,    31,   137,    90,    72,   195,   170,    71,   171,
     196,   148,   101,   150,   101,   172,    32,   177,   155,   127,
     162,    39,    86,    87,   195,    33,    88,   101,   196,   137,
      53,   120,   161,   163,    54,    40,   137,   187,   188,   101,
     137,   121,   122,   137,    51,   166,   137,   202,   204,   101,
     207,   234,   101,   101,   137,   167,   235,    52,   175,   190,
     182,   184,   185,   226,   101,   101,    90,   189,    86,    87,
     201,   203,    88,   220,   221,   195,   195,    55,   137,   196,
     196,   101,   241,   228,   230,    77,   110,   206,   101,   237,
     101,   127,   101,    73,   217,   101,   218,    89,   126,   242,
     231,   219,   232,   137,   247,   137,   127,   101,   137,    56,
      86,    87,    90,   227,    88,   256,   258,   101,    35,    74,
     101,    36,    83,   229,    37,    38,   238,   101,   243,   137,
     101,   137,   101,   239,   101,   116,   244,   101,   137,    89,
     138,   101,    90,   251,   101,   101,    39,   133,   137,   105,
     255,   257,    86,    87,    90,    35,    88,   137,    36,   137,
      40,    37,    38,    77,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    80,   101,    80,   114,   191,
     192,    89,   176,   193,   101,    86,    87,    86,    87,    88,
     259,    88,    84,    85,   101,    96,    90,    40,    90,    68,
     260,   191,   192,   119,    40,   193,   125,   215,   194,   101,
      15,   101,   140,   149,    89,   236,    89,   246,    35,   151,
     152,    36,    40,    90,    37,    38,   168,   169,    15,    90,
     194,    90,   191,   192,    86,    87,   193,   178,    88,   191,
     192,   179,   211,   193,    40,    90,   130,   183,    16,    17,
      18,   212,   213,    47,    48,    49,   186,   200,   208,   205,
      40,    19,    20,    21,   222,    22,    23,    24,    25,    26,
     209,   210,   223,   224,   225,   240,   245,    28,   248,   249,
     115,   250,   254,   111,   181,   123,   132
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-187)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_uint16 yycheck[] =
{
       9,    84,    11,    20,    39,     4,    85,    39,   194,    40,
      75,    72,    27,    96,     4,   197,    27,     7,    33,    32,
      10,    11,    33,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    33,    50,    49,   223,     4,    50,
       0,     7,    27,    77,    91,    80,    91,   130,    33,    27,
       3,     4,    99,    70,     7,    89,    46,   104,    48,   104,
      27,   108,    29,   124,   129,   112,   248,   249,   151,    27,
     109,    27,   117,   152,   113,    33,   123,    33,   143,    32,
      97,   146,    99,     4,     8,    27,     7,     4,     5,    10,
      11,    33,     6,   102,    47,   130,   179,    27,   130,    29,
     179,   118,    27,   120,    27,   150,     6,   154,    33,   154,
      33,    32,     3,     4,   197,     4,     7,    27,   197,   128,
      32,    12,   131,    33,    32,    46,   135,   172,   173,    27,
     139,    22,    23,   142,     8,    33,   145,   184,   185,    27,
     187,   224,    27,    27,   153,    33,   225,     8,    33,    33,
     159,   168,   169,   214,    27,    27,    47,   174,     3,     4,
      33,    33,     7,   208,   209,   248,   249,    32,   177,   248,
     249,    27,   233,   220,   221,    32,    33,    33,    27,   226,
      27,   226,    27,     4,    33,    27,    33,    32,    33,   234,
      27,    33,    29,   202,   241,   204,   241,    27,   207,    28,
       3,     4,    47,    33,     7,   252,   253,    27,     4,     4,
      27,     7,     3,    33,    10,    11,    33,    27,   235,   228,
      27,   230,    27,    33,    27,    29,    33,    27,   237,    32,
      33,    27,    47,    33,    27,    27,    32,    33,   247,    28,
      33,    33,     3,     4,    47,     4,     7,   256,     7,   258,
      46,    10,    11,    32,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    32,    27,    32,    33,     3,
       4,    32,    33,     7,    27,     3,     4,     3,     4,     7,
      33,     7,    32,    32,    27,    32,    47,    46,    47,    48,
      33,     3,     4,    28,    46,     7,     4,    31,    32,    27,
       4,    27,     3,     3,    32,    33,    32,    33,     4,    32,
      32,     7,    46,    47,    10,    11,    33,    33,     4,    47,
      32,    47,     3,     4,     3,     4,     7,    33,     7,     3,
       4,    30,    13,     7,    46,    47,    32,     3,    24,    25,
      26,    22,    23,    34,    35,    36,     3,    29,    33,    29,
      46,    37,    38,    39,     3,    41,    42,    43,    44,    45,
      33,    28,    32,    32,    32,     3,    29,    11,    33,    33,
      81,    33,    33,    78,   159,    89,    97
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    32,    49,    52,    53,    40,     0,     4,     5,    54,
      27,    55,    56,    80,    85,     4,    24,    25,    26,    37,
      38,    39,    41,    42,    43,    44,    45,    33,    56,     8,
      81,     6,     6,     4,    57,     4,     7,    10,    11,    32,
      46,    67,    74,    75,    83,    87,    67,    34,    35,    36,
      58,     8,     8,    32,    32,    32,    28,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    48,    72,
      73,    75,    83,     4,     4,    59,    82,    32,    60,    61,
      32,    63,    64,     3,    32,    32,     3,     4,     7,    32,
      47,    76,    77,    78,    84,    86,    32,    70,    71,    66,
      67,    27,    79,    80,    76,    28,    33,    82,    62,    84,
      33,    61,    65,    83,    33,    64,    29,    86,    87,    28,
      12,    22,    23,    78,    84,     4,    33,    77,    79,    86,
      32,    67,    71,    33,    67,    79,    33,    80,    33,    79,
       3,    33,    79,    59,    33,    79,    59,    77,    67,     3,
      67,    32,    32,    79,    76,    33,    82,    33,    50,    68,
      69,    80,    33,    33,    27,    29,    33,    33,    33,    33,
      27,    29,    77,    86,    87,    33,    33,    79,    33,    30,
      33,    69,    80,     3,    67,    67,     3,    77,    77,    67,
      33,     3,     4,     7,    32,    86,    87,    88,    89,    90,
      29,    33,    79,    33,    79,    29,    33,    79,    33,    33,
      28,    13,    22,    23,    90,    31,    89,    33,    33,    33,
      77,    77,     3,    32,    32,    32,    76,    33,    79,    33,
      79,    27,    29,    90,    86,    87,    33,    79,    33,    33,
       3,    76,    77,    67,    33,    29,    33,    79,    33,    33,
      33,    33,    89,    89,    33,    33,    79,    33,    79,    33,
      33
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])



/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YYLVAL_INITIALIZE
# define YYLVAL_INITIALIZE()
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  YYLVAL_INITIALIZE ();
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1813 of yacc.c  */
#line 149 "smtlib.y"
    {
      EXPR = *(yyvsp[(1) - (1)].node);
      delete (yyvsp[(1) - (1)].node);
      YYACCEPT;
    }
    break;

  case 3:
/* Line 1813 of yacc.c  */
#line 158 "smtlib.y"
    {
      if (!QUERYPARSED)
        (yyvsp[(4) - (5)].vec)->push_back(CVC3::Expr(VC->listExpr("_CHECKSAT", CVC3::Expr(VC->idExpr("_TRUE_EXPR")))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_SEQ",*(yyvsp[(4) - (5)].vec)));
      delete (yyvsp[(4) - (5)].vec);
    }
    break;

  case 4:
/* Line 1813 of yacc.c  */
#line 165 "smtlib.y"
    { 
      TMP->done = true;
      (yyval.node) = new CVC3::Expr();
    }
    break;

  case 5:
/* Line 1813 of yacc.c  */
#line 173 "smtlib.y"
    {
      TRANSLATOR->setBenchName(*(yyvsp[(1) - (1)].str));
      (yyval.node) = NULL;
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 6:
/* Line 1813 of yacc.c  */
#line 179 "smtlib.y"
    {
      TRANSLATOR->setBenchName(*(yyvsp[(1) - (1)].str));
      (yyval.node) = NULL;
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 7:
/* Line 1813 of yacc.c  */
#line 188 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      if ((yyvsp[(1) - (1)].node)) {
	(yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
	delete (yyvsp[(1) - (1)].node);
      }
    }
    break;

  case 8:
/* Line 1813 of yacc.c  */
#line 196 "smtlib.y"
    {
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      if ((yyvsp[(2) - (2)].node)) {
	(yyval.vec)->push_back(*(yyvsp[(2) - (2)].node));
	delete (yyvsp[(2) - (2)].node);
      }
    }
    break;

  case 9:
/* Line 1813 of yacc.c  */
#line 207 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_ASSERT", *(yyvsp[(3) - (3)].node)));
      delete (yyvsp[(3) - (3)].node);
    }
    break;

  case 10:
/* Line 1813 of yacc.c  */
#line 212 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_CHECKSAT", *(yyvsp[(3) - (3)].node)));
      QUERYPARSED = true;
      delete (yyvsp[(3) - (3)].node);
    }
    break;

  case 11:
/* Line 1813 of yacc.c  */
#line 218 "smtlib.y"
    {
      (yyval.node) = NULL;
    }
    break;

  case 12:
/* Line 1813 of yacc.c  */
#line 222 "smtlib.y"
    {
      TRANSLATOR->setSource(*(yyvsp[(3) - (3)].str));
      (yyval.node) = NULL;
      delete (yyvsp[(3) - (3)].str);
    }
    break;

  case 13:
/* Line 1813 of yacc.c  */
#line 228 "smtlib.y"
    {
      TRANSLATOR->setCategory(*(yyvsp[(3) - (3)].str));
      (yyval.node) = NULL;
      delete (yyvsp[(3) - (3)].str);
    }
    break;

  case 14:
/* Line 1813 of yacc.c  */
#line 234 "smtlib.y"
    {
      ARRAYSENABLED = false;
      BVENABLED = false;
      CVC3::Expr cmd;
      if (*(yyvsp[(3) - (3)].str) == "QF_UF") {
        cmd = CVC3::Expr(VC->listExpr("_TYPE", VC->idExpr("U")));
      }
      else if (*(yyvsp[(3) - (3)].str) == "QF_A" ||
               *(yyvsp[(3) - (3)].str) == "QF_AX") {
        ARRAYSENABLED = true;
        std::vector<CVC3::Expr> tmp;
        tmp.push_back(VC->listExpr("_TYPE", VC->idExpr("Index")));
        tmp.push_back(VC->listExpr("_TYPE", VC->idExpr("Element")));
        tmp.push_back(VC->listExpr("_TYPEDEF", VC->idExpr("Array"),
                                   VC->listExpr("_ARRAY",
                                                VC->idExpr("Index"),
                                                VC->idExpr("Element"))));
        cmd = CVC3::Expr(VC->listExpr("_SEQ", tmp));
      }
      else if (*(yyvsp[(3) - (3)].str) == "QF_AUFLIA" ||
               *(yyvsp[(3) - (3)].str) == "AUFLIA") {
        ARRAYSENABLED = true;
        std::vector<CVC3::Expr> tmp;
        tmp.push_back(VC->listExpr("_TYPEDEF", VC->idExpr("Array"),
                                   VC->listExpr("_ARRAY",
                                                VC->idExpr("_INT"),
                                                VC->idExpr("_INT"))));
        cmd = CVC3::Expr(VC->listExpr("_SEQ", tmp));
      }
      else if (*(yyvsp[(3) - (3)].str) == "QF_AUFLIRA" ||
               *(yyvsp[(3) - (3)].str) == "AUFLIRA" ||
               *(yyvsp[(3) - (3)].str) == "QF_AUFNIRA" ||
               *(yyvsp[(3) - (3)].str) == "AUFNIRA") {
        ARRAYSENABLED = true;
        std::vector<CVC3::Expr> tmp;
        tmp.push_back(VC->listExpr("_TYPEDEF", VC->idExpr("Array1"),
                                   VC->listExpr("_ARRAY",
                                                VC->idExpr("_INT"),
                                                VC->idExpr("_REAL"))));
        tmp.push_back(VC->listExpr("_TYPEDEF", VC->idExpr("Array2"),
                                   VC->listExpr("_ARRAY",
                                                VC->idExpr("_INT"),
                                                VC->idExpr("Array1"))));
        cmd = CVC3::Expr(VC->listExpr("_SEQ", tmp));
      }
      else if (*(yyvsp[(3) - (3)].str) == "QF_AUFBV" ||
               *(yyvsp[(3) - (3)].str) == "QF_ABV") {
        ARRAYSENABLED = true;
        BVENABLED = true;
//         $$ = new CVC3::Expr(VC->listExpr("_TYPEDEF", VC->idExpr("Array"),
//                                          VC->listExpr("_ARRAY",
//                                                       VC->listExpr("_BITVECTOR", VC->ratExpr(32)),
//                                                       VC->listExpr("_BITVECTOR", VC->ratExpr(8)))));
      }
      else if (*(yyvsp[(3) - (3)].str) == "QF_BV" ||
               *(yyvsp[(3) - (3)].str) == "QF_UFBV") {
        BVENABLED = true;
      }
    // This enables the new arith for QF_LRA, but this results in assertion failures in DEBUG mode
//       else if (*$3 == "QF_LRA") {
//         cmd = CVC3::Expr(VC->listExpr("_OPTION", VC->stringExpr("arith-new"), VC->ratExpr(1)));
//       }

      CVC3::Expr cmd2;
      if (*(yyvsp[(3) - (3)].str) == "AUFLIA" ||
          *(yyvsp[(3) - (3)].str) == "AUFLIRA" ||
          *(yyvsp[(3) - (3)].str) == "AUFNIRA" ||
          *(yyvsp[(3) - (3)].str) == "LRA" ||
          *(yyvsp[(3) - (3)].str) == "UFNIA") {
        cmd2 = CVC3::Expr(VC->listExpr("_OPTION", VC->stringExpr("quant-complete-inst"), VC->ratExpr(1)));
      }
//    e if (*$3 == "QF_NIA" ||
//          *$3 == "QF_UFNRA") {
//    md2 = CVC3::Expr(VC->listExpr("_OPTION", VC->stringExpr("unknown-check-model"), VC->ratExpr(1)));
//    
//    else if (*$3 == "QF_LIA" ||
//             *$3 == "QF_AUFLIA" ||
//             *$3 == "QF_AX") {
//      cmd2 = CVC3::Expr(VC->listExpr("_OPTION", VC->stringExpr("pp-budget"), VC->ratExpr(5000)));
//    }

      if (cmd.isNull()) {
        if (cmd2.isNull()) {
          (yyval.node) = NULL;
        }
        else (yyval.node) = new CVC3::Expr(cmd2);
      }
      else {
        if (!cmd2.isNull()) {
          cmd = CVC3::Expr(VC->listExpr("_SEQ", cmd, cmd2));
        }
        (yyval.node) = new CVC3::Expr(cmd);
      }
      delete (yyvsp[(3) - (3)].str);
    }
    break;

  case 15:
/* Line 1813 of yacc.c  */
#line 330 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_TYPE", *(yyvsp[(4) - (5)].vec)));
      delete (yyvsp[(4) - (5)].vec);
    }
    break;

  case 16:
/* Line 1813 of yacc.c  */
#line 335 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_SEQ", *(yyvsp[(4) - (5)].vec)));
      delete (yyvsp[(4) - (5)].vec);
    }
    break;

  case 17:
/* Line 1813 of yacc.c  */
#line 340 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_SEQ", *(yyvsp[(4) - (5)].vec)));
      delete (yyvsp[(4) - (5)].vec);
    }
    break;

  case 18:
/* Line 1813 of yacc.c  */
#line 345 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_ANNOTATION",
                                       VC->listExpr(VC->stringExpr("notes"), VC->stringExpr(*(yyvsp[(3) - (3)].str)))));
      delete (yyvsp[(3) - (3)].str);
    }
    break;

  case 19:
/* Line 1813 of yacc.c  */
#line 351 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(VC->idExpr("_"+*(yyvsp[(3) - (3)].str))));
      delete (yyvsp[(3) - (3)].str);
    }
    break;

  case 20:
/* Line 1813 of yacc.c  */
#line 356 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_ANNOTATION", *(yyvsp[(1) - (1)].node)));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 21:
/* Line 1813 of yacc.c  */
#line 364 "smtlib.y"
    {
      BVSIZE = atoi((yyvsp[(3) - (4)].str)->c_str());
      delete (yyvsp[(3) - (4)].str);
      (yyval.str) = (yyvsp[(1) - (4)].str);
    }
    break;

  case 22:
/* Line 1813 of yacc.c  */
#line 370 "smtlib.y"
    {
      (yyval.str) = (yyvsp[(1) - (1)].str);
    }
    break;

  case 23:
/* Line 1813 of yacc.c  */
#line 376 "smtlib.y"
    { TRANSLATOR->setStatus("sat"); (yyval.node) = NULL; }
    break;

  case 24:
/* Line 1813 of yacc.c  */
#line 377 "smtlib.y"
    { TRANSLATOR->setStatus("unsat"); (yyval.node) = NULL; }
    break;

  case 25:
/* Line 1813 of yacc.c  */
#line 378 "smtlib.y"
    { TRANSLATOR->setStatus("unknown"); (yyval.node) = NULL; }
    break;

  case 26:
/* Line 1813 of yacc.c  */
#line 383 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 27:
/* Line 1813 of yacc.c  */
#line 389 "smtlib.y"
    { 
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 28:
/* Line 1813 of yacc.c  */
#line 398 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 29:
/* Line 1813 of yacc.c  */
#line 405 "smtlib.y"
    {
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 30:
/* Line 1813 of yacc.c  */
#line 414 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(2) - (4)].node);
      delete (yyvsp[(3) - (4)].vec);
    }
    break;

  case 31:
/* Line 1813 of yacc.c  */
#line 419 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(2) - (3)].node);
    }
    break;

  case 32:
/* Line 1813 of yacc.c  */
#line 426 "smtlib.y"
    {
      if ((yyvsp[(2) - (2)].vec)->size() == 1) {
        (yyval.node) = new CVC3::Expr(VC->listExpr("_CONST", VC->listExpr(*(yyvsp[(1) - (2)].vec)), (*(yyvsp[(2) - (2)].vec))[0]));
      }
      else {
        CVC3::Expr tmp(VC->listExpr("_ARROW", *(yyvsp[(2) - (2)].vec)));
        (yyval.node) = new CVC3::Expr(VC->listExpr("_CONST", VC->listExpr(*(yyvsp[(1) - (2)].vec)), tmp));
      }
      delete (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].vec);
    }
    break;

  case 33:
/* Line 1813 of yacc.c  */
#line 441 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 34:
/* Line 1813 of yacc.c  */
#line 448 "smtlib.y"
    {
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 35:
/* Line 1813 of yacc.c  */
#line 457 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(2) - (4)].node);
      delete (yyvsp[(3) - (4)].vec);
    }
    break;

  case 36:
/* Line 1813 of yacc.c  */
#line 462 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(2) - (3)].node);
    }
    break;

  case 37:
/* Line 1813 of yacc.c  */
#line 469 "smtlib.y"
    {
      std::vector<CVC3::Expr> tmp(*(yyvsp[(2) - (2)].vec));
      tmp.push_back(VC->idExpr("_BOOLEAN"));
      CVC3::Expr tmp2(VC->listExpr("_ARROW", tmp));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_CONST", VC->listExpr(*(yyvsp[(1) - (2)].node)), tmp2));
      delete (yyvsp[(1) - (2)].node);
      delete (yyvsp[(2) - (2)].vec);
    }
    break;

  case 38:
/* Line 1813 of yacc.c  */
#line 478 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_CONST", VC->listExpr(*(yyvsp[(1) - (1)].node)),
                                       VC->idExpr("_BOOLEAN")));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 39:
/* Line 1813 of yacc.c  */
#line 487 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 40:
/* Line 1813 of yacc.c  */
#line 494 "smtlib.y"
    {
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 41:
/* Line 1813 of yacc.c  */
#line 503 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(1) - (1)].node);
    }
    break;

  case 42:
/* Line 1813 of yacc.c  */
#line 507 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (5)].str), *(yyvsp[(3) - (5)].vec)));
      delete (yyvsp[(2) - (5)].str);
      delete (yyvsp[(3) - (5)].vec);
      delete (yyvsp[(4) - (5)].vec);
    }
    break;

  case 43:
/* Line 1813 of yacc.c  */
#line 514 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (4)].str), *(yyvsp[(3) - (4)].vec)));
      delete (yyvsp[(2) - (4)].str);
      delete (yyvsp[(3) - (4)].vec);
    }
    break;

  case 44:
/* Line 1813 of yacc.c  */
#line 520 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (6)].str), VC->listExpr(*(yyvsp[(3) - (6)].vec)), *(yyvsp[(4) - (6)].node), VC->listExpr((*(yyvsp[(5) - (6)].pat_ann)).first)));
      delete (yyvsp[(2) - (6)].str);
      delete (yyvsp[(3) - (6)].vec);
      delete (yyvsp[(4) - (6)].node);
      delete (yyvsp[(5) - (6)].pat_ann);
    }
    break;

  case 45:
/* Line 1813 of yacc.c  */
#line 528 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (5)].str), VC->listExpr(*(yyvsp[(3) - (5)].vec)), *(yyvsp[(4) - (5)].node)));
      delete (yyvsp[(2) - (5)].str);
      delete (yyvsp[(3) - (5)].vec);
      delete (yyvsp[(4) - (5)].node);
    }
    break;

  case 46:
/* Line 1813 of yacc.c  */
#line 535 "smtlib.y"
    {
      CVC3::Expr e(VC->listExpr(VC->listExpr(*(yyvsp[(4) - (9)].node), *(yyvsp[(5) - (9)].node))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(7) - (9)].node)));
      delete (yyvsp[(4) - (9)].node);
      delete (yyvsp[(5) - (9)].node);
      delete (yyvsp[(7) - (9)].node);
      delete (yyvsp[(8) - (9)].vec);
    }
    break;

  case 47:
/* Line 1813 of yacc.c  */
#line 544 "smtlib.y"
    {
      CVC3::Expr e(VC->listExpr(VC->listExpr(*(yyvsp[(4) - (8)].node), *(yyvsp[(5) - (8)].node))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(7) - (8)].node)));
      delete (yyvsp[(4) - (8)].node);
      delete (yyvsp[(5) - (8)].node);
      delete (yyvsp[(7) - (8)].node);
    }
    break;

  case 48:
/* Line 1813 of yacc.c  */
#line 552 "smtlib.y"
    {
      CVC3::Expr e(VC->listExpr(VC->listExpr(*(yyvsp[(4) - (9)].node), *(yyvsp[(5) - (9)].node))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(7) - (9)].node)));
      delete (yyvsp[(4) - (9)].node);
      delete (yyvsp[(5) - (9)].node);
      delete (yyvsp[(7) - (9)].node);
      delete (yyvsp[(8) - (9)].vec);
    }
    break;

  case 49:
/* Line 1813 of yacc.c  */
#line 561 "smtlib.y"
    {
      CVC3::Expr e(VC->listExpr(VC->listExpr(*(yyvsp[(4) - (8)].node), *(yyvsp[(5) - (8)].node))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(7) - (8)].node)));
      delete (yyvsp[(4) - (8)].node);
      delete (yyvsp[(5) - (8)].node);
      delete (yyvsp[(7) - (8)].node);
    }
    break;

  case 50:
/* Line 1813 of yacc.c  */
#line 572 "smtlib.y"
    {
       (yyval.pat_ann) = new std::pair<std::vector<CVC3::Expr>, std::vector<CVC3::Expr> >;
       (yyval.pat_ann)->first.push_back(*(yyvsp[(1) - (1)].node));
       delete (yyvsp[(1) - (1)].node);
     }
    break;

  case 51:
/* Line 1813 of yacc.c  */
#line 578 "smtlib.y"
    {
       (yyval.pat_ann) = new std::pair<std::vector<CVC3::Expr>, std::vector<CVC3::Expr> >;
       (yyval.pat_ann)->second.push_back(*(yyvsp[(1) - (1)].node));
       delete (yyvsp[(1) - (1)].node);
     }
    break;

  case 52:
/* Line 1813 of yacc.c  */
#line 584 "smtlib.y"
    {
       (yyvsp[(1) - (2)].pat_ann)->first.push_back(*(yyvsp[(2) - (2)].node));
       (yyval.pat_ann) = (yyvsp[(1) - (2)].pat_ann);
       delete (yyvsp[(2) - (2)].node);
     }
    break;

  case 53:
/* Line 1813 of yacc.c  */
#line 590 "smtlib.y"
    {
       (yyvsp[(1) - (2)].pat_ann)->second.push_back(*(yyvsp[(2) - (2)].node));
       (yyval.pat_ann) = (yyvsp[(1) - (2)].pat_ann);
       delete (yyvsp[(2) - (2)].node);
     }
    break;

  case 54:
/* Line 1813 of yacc.c  */
#line 598 "smtlib.y"
    {
       (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(3) - (4)].vec)));
       delete (yyvsp[(3) - (4)].vec);
     }
    break;

  case 55:
/* Line 1813 of yacc.c  */
#line 605 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 56:
/* Line 1813 of yacc.c  */
#line 611 "smtlib.y"
    {
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec); 
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 57:
/* Line 1813 of yacc.c  */
#line 620 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (4)].node), *(yyvsp[(3) - (4)].node)));
      delete (yyvsp[(2) - (4)].node);
      delete (yyvsp[(3) - (4)].node);
    }
    break;

  case 58:
/* Line 1813 of yacc.c  */
#line 629 "smtlib.y"
    {
      (yyval.str) = new std::string("_EXISTS");
    }
    break;

  case 59:
/* Line 1813 of yacc.c  */
#line 633 "smtlib.y"
    {
      (yyval.str) = new std::string("_FORALL");
    }
    break;

  case 60:
/* Line 1813 of yacc.c  */
#line 640 "smtlib.y"
    {
      (yyval.str) = new std::string("_NOT");
    }
    break;

  case 61:
/* Line 1813 of yacc.c  */
#line 644 "smtlib.y"
    {
      (yyval.str) = new std::string("_IMPLIES");
    }
    break;

  case 62:
/* Line 1813 of yacc.c  */
#line 648 "smtlib.y"
    {
      (yyval.str) = new std::string("_IF");
    }
    break;

  case 63:
/* Line 1813 of yacc.c  */
#line 652 "smtlib.y"
    {
      (yyval.str) = new std::string("_AND");
    }
    break;

  case 64:
/* Line 1813 of yacc.c  */
#line 656 "smtlib.y"
    {
      (yyval.str) = new std::string("_OR");
    }
    break;

  case 65:
/* Line 1813 of yacc.c  */
#line 660 "smtlib.y"
    {
      (yyval.str) = new std::string("_XOR");
    }
    break;

  case 66:
/* Line 1813 of yacc.c  */
#line 664 "smtlib.y"
    {
      (yyval.str) = new std::string("_IFF");
    }
    break;

  case 67:
/* Line 1813 of yacc.c  */
#line 671 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(1) - (1)].node);
    }
    break;

  case 68:
/* Line 1813 of yacc.c  */
#line 675 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(2) - (4)].node);
      delete (yyvsp[(3) - (4)].vec);
    }
    break;

  case 69:
/* Line 1813 of yacc.c  */
#line 680 "smtlib.y"
    {
      if ((yyvsp[(4) - (5)].vec)->size() == 1 && (*(yyvsp[(4) - (5)].vec))[0].getName() == "transclose" &&
          (yyvsp[(3) - (5)].vec)->size() == 2) {
        (yyval.node) = new CVC3::Expr(VC->listExpr("_TRANS_CLOSURE",
                                        *(yyvsp[(2) - (5)].node), (*(yyvsp[(3) - (5)].vec))[0], (*(yyvsp[(3) - (5)].vec))[1]));
      }
      else {
        std::vector<CVC3::Expr> tmp;
        tmp.push_back(*(yyvsp[(2) - (5)].node));
        tmp.insert(tmp.end(), (yyvsp[(3) - (5)].vec)->begin(), (yyvsp[(3) - (5)].vec)->end());
        (yyval.node) = new CVC3::Expr(VC->listExpr(tmp));
      }
      delete (yyvsp[(2) - (5)].node);
      delete (yyvsp[(3) - (5)].vec);
      delete (yyvsp[(4) - (5)].vec);
    }
    break;

  case 70:
/* Line 1813 of yacc.c  */
#line 697 "smtlib.y"
    {
      std::vector<CVC3::Expr> tmp;
      tmp.push_back(*(yyvsp[(2) - (4)].node));
      tmp.insert(tmp.end(), (yyvsp[(3) - (4)].vec)->begin(), (yyvsp[(3) - (4)].vec)->end());
      (yyval.node) = new CVC3::Expr(VC->listExpr(tmp));
      delete (yyvsp[(2) - (4)].node);
      delete (yyvsp[(3) - (4)].vec);
    }
    break;

  case 71:
/* Line 1813 of yacc.c  */
#line 706 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_DISTINCT", *(yyvsp[(3) - (5)].vec)));

//       std::vector<CVC3::Expr> tmp;
//       tmp.push_back(*$2);
//       tmp.insert(tmp.end(), $3->begin(), $3->end());
//       $$ = new CVC3::Expr(VC->listExpr(tmp));
//       for (unsigned i = 0; i < (*$3).size(); ++i) {
//         tmp.push_back(($3)[i])
// 	for (unsigned j = i+1; j < (*$3).size(); ++j) {
// 	  tmp.push_back(VC->listExpr("_NEQ", (*$3)[i], (*$3)[j]));
// 	}
//       }
//       $$ = new CVC3::Expr(VC->listExpr("_AND", tmp));
      delete (yyvsp[(3) - (5)].vec);
      delete (yyvsp[(4) - (5)].vec);
    }
    break;

  case 72:
/* Line 1813 of yacc.c  */
#line 724 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_DISTINCT", *(yyvsp[(3) - (4)].vec)));
//       std::vector<CVC3::Expr> tmp;
//       for (unsigned i = 0; i < (*$3).size(); ++i) {
// 	for (unsigned j = i+1; j < (*$3).size(); ++j) {
// 	  tmp.push_back(VC->listExpr("_NEQ", (*$3)[i], (*$3)[j]));
// 	}
//       }
//       $$ = new CVC3::Expr(VC->listExpr("_AND", tmp));
      delete (yyvsp[(3) - (4)].vec);
    }
    break;

  case 73:
/* Line 1813 of yacc.c  */
#line 739 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->idExpr("_TRUE_EXPR"));
    }
    break;

  case 74:
/* Line 1813 of yacc.c  */
#line 743 "smtlib.y"
    { 
      (yyval.node) = new CVC3::Expr(VC->idExpr("_FALSE_EXPR"));
    }
    break;

  case 75:
/* Line 1813 of yacc.c  */
#line 747 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(1) - (1)].node);
    }
    break;

  case 76:
/* Line 1813 of yacc.c  */
#line 751 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(1) - (1)].node);
    }
    break;

  case 77:
/* Line 1813 of yacc.c  */
#line 758 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 78:
/* Line 1813 of yacc.c  */
#line 764 "smtlib.y"
    {
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec); 
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 79:
/* Line 1813 of yacc.c  */
#line 773 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(1) - (1)].node);
    }
    break;

  case 80:
/* Line 1813 of yacc.c  */
#line 777 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(2) - (4)].node);
      delete (yyvsp[(3) - (4)].vec);
    }
    break;

  case 81:
/* Line 1813 of yacc.c  */
#line 782 "smtlib.y"
    {
      (yyvsp[(2) - (5)].vec)->insert((yyvsp[(2) - (5)].vec)->end(), (yyvsp[(3) - (5)].vec)->begin(), (yyvsp[(3) - (5)].vec)->end());
      (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (5)].vec)));
      delete (yyvsp[(2) - (5)].vec);
      delete (yyvsp[(3) - (5)].vec);
      delete (yyvsp[(4) - (5)].vec);
    }
    break;

  case 82:
/* Line 1813 of yacc.c  */
#line 790 "smtlib.y"
    {
      (yyvsp[(2) - (4)].vec)->insert((yyvsp[(2) - (4)].vec)->end(), (yyvsp[(3) - (4)].vec)->begin(), (yyvsp[(3) - (4)].vec)->end());
      (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (4)].vec)));
      delete (yyvsp[(2) - (4)].vec);
      delete (yyvsp[(3) - (4)].vec);
    }
    break;

  case 83:
/* Line 1813 of yacc.c  */
#line 797 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_IF", *(yyvsp[(3) - (7)].node), *(yyvsp[(4) - (7)].node), *(yyvsp[(5) - (7)].node)));
      delete (yyvsp[(3) - (7)].node);
      delete (yyvsp[(4) - (7)].node);
      delete (yyvsp[(5) - (7)].node);
      delete (yyvsp[(6) - (7)].vec);
    }
    break;

  case 84:
/* Line 1813 of yacc.c  */
#line 805 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_IF", *(yyvsp[(3) - (6)].node), *(yyvsp[(4) - (6)].node), *(yyvsp[(5) - (6)].node)));
      delete (yyvsp[(3) - (6)].node);
      delete (yyvsp[(4) - (6)].node);
      delete (yyvsp[(5) - (6)].node);
    }
    break;

  case 85:
/* Line 1813 of yacc.c  */
#line 812 "smtlib.y"
    {
      CVC3::Expr e(VC->listExpr(VC->listExpr(*(yyvsp[(4) - (9)].node), *(yyvsp[(5) - (9)].node))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(7) - (9)].node)));
      delete (yyvsp[(4) - (9)].node);
      delete (yyvsp[(5) - (9)].node);
      delete (yyvsp[(7) - (9)].node);
      delete (yyvsp[(8) - (9)].vec);
    }
    break;

  case 86:
/* Line 1813 of yacc.c  */
#line 821 "smtlib.y"
    {
      CVC3::Expr e(VC->listExpr(VC->listExpr(*(yyvsp[(4) - (8)].node), *(yyvsp[(5) - (8)].node))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(7) - (8)].node)));
      delete (yyvsp[(4) - (8)].node);
      delete (yyvsp[(5) - (8)].node);
      delete (yyvsp[(7) - (8)].node);
    }
    break;

  case 87:
/* Line 1813 of yacc.c  */
#line 829 "smtlib.y"
    {
      CVC3::Expr e(VC->listExpr(VC->listExpr(*(yyvsp[(4) - (9)].node), *(yyvsp[(5) - (9)].node))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(7) - (9)].node)));
      delete (yyvsp[(4) - (9)].node);
      delete (yyvsp[(5) - (9)].node);
      delete (yyvsp[(7) - (9)].node);
      delete (yyvsp[(8) - (9)].vec);
    }
    break;

  case 88:
/* Line 1813 of yacc.c  */
#line 838 "smtlib.y"
    {
      CVC3::Expr e(VC->listExpr(VC->listExpr(*(yyvsp[(4) - (8)].node), *(yyvsp[(5) - (8)].node))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(7) - (8)].node)));
      delete (yyvsp[(4) - (8)].node);
      delete (yyvsp[(5) - (8)].node);
      delete (yyvsp[(7) - (8)].node);
    }
    break;

  case 89:
/* Line 1813 of yacc.c  */
#line 849 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(1) - (1)].node);
    }
    break;

  case 90:
/* Line 1813 of yacc.c  */
#line 853 "smtlib.y"
    {
      if ((yyvsp[(1) - (1)].vec)->size() == 1) {
        (yyval.node) = new CVC3::Expr(((*(yyvsp[(1) - (1)].vec))[0]));
      }
      else {
        (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(1) - (1)].vec)));
      }
      delete (yyvsp[(1) - (1)].vec);
    }
    break;

  case 91:
/* Line 1813 of yacc.c  */
#line 866 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 92:
/* Line 1813 of yacc.c  */
#line 872 "smtlib.y"
    {
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 93:
/* Line 1813 of yacc.c  */
#line 882 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(VC->stringExpr(*(yyvsp[(1) - (1)].str))));
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 94:
/* Line 1813 of yacc.c  */
#line 887 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(VC->stringExpr(*(yyvsp[(1) - (2)].str)), VC->stringExpr(*(yyvsp[(2) - (2)].str))));
      delete (yyvsp[(1) - (2)].str);
      delete (yyvsp[(2) - (2)].str);
    }
    break;

  case 95:
/* Line 1813 of yacc.c  */
#line 896 "smtlib.y"
    {
      (yyval.str) = (yyvsp[(1) - (1)].str);
    }
    break;

  case 96:
/* Line 1813 of yacc.c  */
#line 904 "smtlib.y"
    {
      if (BVENABLED && *(yyvsp[(1) - (4)].str) == "BitVec") {
        (yyval.node) = new CVC3::Expr(VC->listExpr("_BITVECTOR", VC->ratExpr(*(yyvsp[(3) - (4)].str))));
      }
      else {
        (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(1) - (4)].str), VC->ratExpr(*(yyvsp[(3) - (4)].str))));
      }
      delete (yyvsp[(1) - (4)].str);
      delete (yyvsp[(3) - (4)].str);
    }
    break;

  case 97:
/* Line 1813 of yacc.c  */
#line 915 "smtlib.y"
    {
      if (BVENABLED && ARRAYSENABLED && *(yyvsp[(1) - (6)].str) == "Array") {
        (yyval.node) = new CVC3::Expr(VC->listExpr("_ARRAY",
                                         VC->listExpr("_BITVECTOR", VC->ratExpr(*(yyvsp[(3) - (6)].str))),
                                         VC->listExpr("_BITVECTOR", VC->ratExpr(*(yyvsp[(5) - (6)].str)))));
      }
      else {
        (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(1) - (6)].str), VC->ratExpr(*(yyvsp[(3) - (6)].str)), VC->ratExpr(*(yyvsp[(5) - (6)].str))));
      }
      delete (yyvsp[(1) - (6)].str);
      delete (yyvsp[(3) - (6)].str);
      delete (yyvsp[(5) - (6)].str);
    }
    break;

  case 98:
/* Line 1813 of yacc.c  */
#line 929 "smtlib.y"
    { 
      if (*(yyvsp[(1) - (1)].str) == "Real") {
	(yyval.node) = new CVC3::Expr(VC->idExpr("_REAL"));
      } else if (*(yyvsp[(1) - (1)].str) == "Int") {
	(yyval.node) = new CVC3::Expr(VC->idExpr("_INT"));
      } else {
	(yyval.node) = new CVC3::Expr(VC->idExpr(*(yyvsp[(1) - (1)].str)));
      }
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 99:
/* Line 1813 of yacc.c  */
#line 943 "smtlib.y"
    {
      if (BVENABLED && (*(yyvsp[(1) - (1)].str) == "bvlt" || *(yyvsp[(1) - (1)].str) == "bvult")) {
        (yyval.node) = new CVC3::Expr(VC->idExpr("_BVLT"));
      }
      else if (BVENABLED && (*(yyvsp[(1) - (1)].str) == "bvleq" || *(yyvsp[(1) - (1)].str) == "bvule")) {
        (yyval.node) = new CVC3::Expr(VC->idExpr("_BVLE"));
      }
      else if (BVENABLED && (*(yyvsp[(1) - (1)].str) == "bvgeq" || *(yyvsp[(1) - (1)].str) == "bvuge")) {
        (yyval.node) = new CVC3::Expr(VC->idExpr("_BVGE"));
      }
      else if (BVENABLED && (*(yyvsp[(1) - (1)].str) == "bvgt" || *(yyvsp[(1) - (1)].str) == "bvugt")) {
        (yyval.node) = new CVC3::Expr(VC->idExpr("_BVGT"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvslt") {
        (yyval.node) = new CVC3::Expr(VC->idExpr("_BVSLT"));
      }
      else if (BVENABLED && (*(yyvsp[(1) - (1)].str) == "bvsleq" || *(yyvsp[(1) - (1)].str) == "bvsle")) {
        (yyval.node) = new CVC3::Expr(VC->idExpr("_BVSLE"));
      }
      else if (BVENABLED && (*(yyvsp[(1) - (1)].str) == "bvsgeq" || *(yyvsp[(1) - (1)].str) == "bvsge")) {
        (yyval.node) = new CVC3::Expr(VC->idExpr("_BVSGE"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvsgt") {
        (yyval.node) = new CVC3::Expr(VC->idExpr("_BVSGT"));
      }
      else if (*(yyvsp[(1) - (1)].str) == "IsInt") {
        (yyval.node) = new CVC3::Expr(VC->idExpr("_IS_INTEGER"));
      }
      else {
        (yyval.node) = new CVC3::Expr(VC->idExpr(*(yyvsp[(1) - (1)].str)));
      }
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 100:
/* Line 1813 of yacc.c  */
#line 977 "smtlib.y"
    { 
      if ((yyvsp[(1) - (1)].str)->length() == 1) {
	switch ((*(yyvsp[(1) - (1)].str))[0]) {
	  case '=': (yyval.node) = new CVC3::Expr(VC->idExpr("_EQ")); break;
	  case '<': (yyval.node) = new CVC3::Expr(VC->idExpr("_LT")); break;
	  case '>': (yyval.node) = new CVC3::Expr(VC->idExpr("_GT")); break;
	  default: (yyval.node) = new CVC3::Expr(VC->idExpr(*(yyvsp[(1) - (1)].str))); break;
	}
      }
      else {
	if (*(yyvsp[(1) - (1)].str) == "<=") {
	  (yyval.node) = new CVC3::Expr(VC->idExpr("_LE"));
	} else if (*(yyvsp[(1) - (1)].str) == ">=") {
	  (yyval.node) = new CVC3::Expr(VC->idExpr("_GE"));
	}
	else (yyval.node) = new CVC3::Expr(VC->idExpr(*(yyvsp[(1) - (1)].str)));
      }
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 101:
/* Line 1813 of yacc.c  */
#line 1000 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      if (BVENABLED && *(yyvsp[(1) - (4)].str) == "repeat") {
        (yyval.vec)->push_back(VC->idExpr("_BVREPEAT"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (4)].str) == "zero_extend") {
        (yyval.vec)->push_back(VC->idExpr("_BVZEROEXTEND"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (4)].str) == "sign_extend") {
        (yyval.vec)->push_back(VC->idExpr("_SX"));
        (yyval.vec)->push_back(VC->idExpr("_smtlib"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (4)].str) == "rotate_left") {
        (yyval.vec)->push_back(VC->idExpr("_BVROTL"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (4)].str) == "rotate_right") {
        (yyval.vec)->push_back(VC->idExpr("_BVROTR"));
      }
      else if (BVENABLED &&
               (yyvsp[(1) - (4)].str)->size() > 2 &&
               (*(yyvsp[(1) - (4)].str))[0] == 'b' &&
               (*(yyvsp[(1) - (4)].str))[1] == 'v') {
        int i = 2;
        while ((*(yyvsp[(1) - (4)].str))[i] >= '0' && (*(yyvsp[(1) - (4)].str))[i] <= '9') ++i;
        if ((*(yyvsp[(1) - (4)].str))[i] == '\0') {
          (yyval.vec)->push_back(VC->idExpr("_BVCONST"));
          (yyval.vec)->push_back(VC->ratExpr((yyvsp[(1) - (4)].str)->substr(2), 10));
        }
        else (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (4)].str)));
      }
      else (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (4)].str)));
      (yyval.vec)->push_back(VC->ratExpr(*(yyvsp[(3) - (4)].str)));
      delete (yyvsp[(1) - (4)].str);
      delete (yyvsp[(3) - (4)].str);
    }
    break;

  case 102:
/* Line 1813 of yacc.c  */
#line 1036 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      if (BVENABLED && *(yyvsp[(1) - (6)].str) == "extract") {
        (yyval.vec)->push_back(VC->idExpr("_EXTRACT"));
      }
      else (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (6)].str)));
      (yyval.vec)->push_back(VC->ratExpr(*(yyvsp[(3) - (6)].str)));
      (yyval.vec)->push_back(VC->ratExpr(*(yyvsp[(5) - (6)].str)));
      delete (yyvsp[(1) - (6)].str);
      delete (yyvsp[(3) - (6)].str);
      delete (yyvsp[(5) - (6)].str);
    }
    break;

  case 103:
/* Line 1813 of yacc.c  */
#line 1049 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      if (ARRAYSENABLED && *(yyvsp[(1) - (1)].str) == "select") {
        (yyval.vec)->push_back(VC->idExpr("_READ"));
      }
      else if (ARRAYSENABLED && *(yyvsp[(1) - (1)].str) == "store") {
        (yyval.vec)->push_back(VC->idExpr("_WRITE"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bit0") {
        (yyval.vec)->push_back(VC->idExpr("_BVCONST"));
        (yyval.vec)->push_back(VC->ratExpr(0));
        (yyval.vec)->push_back(VC->ratExpr(1));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bit1") {
        (yyval.vec)->push_back(VC->idExpr("_BVCONST"));
        (yyval.vec)->push_back(VC->ratExpr(1));
        (yyval.vec)->push_back(VC->ratExpr(1));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "concat") {
        (yyval.vec)->push_back(VC->idExpr("_CONCAT"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvnot") {
        (yyval.vec)->push_back(VC->idExpr("_BVNEG"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvand") {
        (yyval.vec)->push_back(VC->idExpr("_BVAND"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvor") {
        (yyval.vec)->push_back(VC->idExpr("_BVOR"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvneg") {
        (yyval.vec)->push_back(VC->idExpr("_BVUMINUS"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvadd") {
        (yyval.vec)->push_back(VC->idExpr("_BVPLUS"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvmul") {
        (yyval.vec)->push_back(VC->idExpr("_BVMULT"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvudiv") {
        (yyval.vec)->push_back(VC->idExpr("_BVUDIV"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvurem") {
        (yyval.vec)->push_back(VC->idExpr("_BVUREM"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvshl") {
        (yyval.vec)->push_back(VC->idExpr("_BVSHL"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvlshr") {
        (yyval.vec)->push_back(VC->idExpr("_BVLSHR"));
      }

      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvnand") {
        (yyval.vec)->push_back(VC->idExpr("_BVNAND"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvnor") {
        (yyval.vec)->push_back(VC->idExpr("_BVNOR"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvxor") {
        (yyval.vec)->push_back(VC->idExpr("_BVXOR"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvxnor") {
        (yyval.vec)->push_back(VC->idExpr("_BVXNOR"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvcomp") {
        (yyval.vec)->push_back(VC->idExpr("_BVCOMP"));
      }

      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvsub") {
        (yyval.vec)->push_back(VC->idExpr("_BVSUB"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvsdiv") {
        (yyval.vec)->push_back(VC->idExpr("_BVSDIV"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvsrem") {
        (yyval.vec)->push_back(VC->idExpr("_BVSREM"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvsmod") {
        (yyval.vec)->push_back(VC->idExpr("_BVSMOD"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvashr") {
        (yyval.vec)->push_back(VC->idExpr("_BVASHR"));
      }

      // For backwards compatibility:
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "shift_left0") {
        (yyval.vec)->push_back(VC->idExpr("_CONST_WIDTH_LEFTSHIFT"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "shift_right0") {
        (yyval.vec)->push_back(VC->idExpr("_RIGHTSHIFT"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "sign_extend") {
        (yyval.vec)->push_back(VC->idExpr("_SX"));
        (yyval.vec)->push_back(VC->idExpr("_smtlib"));
      }

      // Bitvector constants
      else if (BVENABLED &&
               (yyvsp[(1) - (1)].str)->size() > 2 &&
               (*(yyvsp[(1) - (1)].str))[0] == 'b' &&
               (*(yyvsp[(1) - (1)].str))[1] == 'v') {
        bool done = false;
        if ((*(yyvsp[(1) - (1)].str))[2] >= '0' && (*(yyvsp[(1) - (1)].str))[2] <= '9') {
          int i = 3;
          while ((*(yyvsp[(1) - (1)].str))[i] >= '0' && (*(yyvsp[(1) - (1)].str))[i] <= '9') ++i;
          if ((*(yyvsp[(1) - (1)].str))[i] == '\0') {
            (yyval.vec)->push_back(VC->idExpr("_BVCONST"));
            (yyval.vec)->push_back(VC->ratExpr((yyvsp[(1) - (1)].str)->substr(2), 10));
            (yyval.vec)->push_back(VC->ratExpr(32));
            done = true;
          }
        }
        else if ((yyvsp[(1) - (1)].str)->size() > 5) {
          std::string s = (yyvsp[(1) - (1)].str)->substr(0,5);
          if (s == "bvbin") {
            int i = 5;
            while ((*(yyvsp[(1) - (1)].str))[i] >= '0' && (*(yyvsp[(1) - (1)].str))[i] <= '1') ++i;
            if ((*(yyvsp[(1) - (1)].str))[i] == '\0') {
              (yyval.vec)->push_back(VC->idExpr("_BVCONST"));
              (yyval.vec)->push_back(VC->ratExpr((yyvsp[(1) - (1)].str)->substr(5), 2));
              (yyval.vec)->push_back(VC->ratExpr(i-5));
              done = true;
            }
          }
          else if (s == "bvhex") {
            int i = 5;
            char c = (*(yyvsp[(1) - (1)].str))[i];
            while ((c >= '0' && c <= '9') ||
                   (c >= 'a' && c <= 'f') ||
                   (c >= 'A' && c <= 'F')) {
              ++i;
              c =(*(yyvsp[(1) - (1)].str))[i];
            }
            if ((*(yyvsp[(1) - (1)].str))[i] == '\0') {
              (yyval.vec)->push_back(VC->idExpr("_BVCONST"));
              (yyval.vec)->push_back(VC->ratExpr((yyvsp[(1) - (1)].str)->substr(5), 16));
              (yyval.vec)->push_back(VC->ratExpr(i-5));
              done = true;
            }
          }
        }
        if (!done) (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (1)].str)));
      }
      else {
        (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (1)].str)));
      }
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 104:
/* Line 1813 of yacc.c  */
#line 1198 "smtlib.y"
    { 
      (yyval.vec) = new std::vector<CVC3::Expr>;
      if ((yyvsp[(1) - (1)].str)->length() == 1) {
	switch ((*(yyvsp[(1) - (1)].str))[0]) {
	case '+': (yyval.vec)->push_back(VC->idExpr("_PLUS")); break;
	case '-': (yyval.vec)->push_back(VC->idExpr("_MINUS")); break;
	case '*': (yyval.vec)->push_back(VC->idExpr("_MULT")); break;
	case '~': (yyval.vec)->push_back(VC->idExpr("_UMINUS")); break;
	case '/': (yyval.vec)->push_back(VC->idExpr("_DIVIDE")); break;
          //        case '=': $$->push_back(VC->idExpr("_EQ")); break;
          //        case '<': $$->push_back(VC->idExpr("_LT")); break;
          //        case '>': $$->push_back(VC->idExpr("_GT")); break;
	default: (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (1)].str)));
	}
      }
      //      else {
      //	if (*$1 == "<=") {
      //	  $$->push_back(VC->idExpr("_LE"));
      //	} else if (*$1 == ">=") {
      //	  $$->push_back(VC->idExpr("_GE"));
      //	}
	else (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (1)].str)));
      //      }
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 105:
/* Line 1813 of yacc.c  */
#line 1224 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      CVC3::Expr e = VC->ratExpr(*(yyvsp[(1) - (1)].str));
      if(VC->getFlags()["translate"].getBool() && (yyvsp[(1) - (1)].str)->find('.') != std::string::npos) {
        e = CVC3::Expr(CVC3::REAL_CONST, e);
      }
      (yyval.vec)->push_back(e);
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 106:
/* Line 1813 of yacc.c  */
#line 1237 "smtlib.y"
    {
      (yyval.str) = (yyvsp[(2) - (2)].str);
    }
    break;

  case 107:
/* Line 1813 of yacc.c  */
#line 1244 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->idExpr("_"+*(yyvsp[(2) - (2)].str)));
      delete (yyvsp[(2) - (2)].str);
    }
    break;

  case 108:
/* Line 1813 of yacc.c  */
#line 1252 "smtlib.y"
    {
      (yyval.node) = new CVC3::Expr(VC->idExpr("_"+*(yyvsp[(2) - (2)].str)));
      delete (yyvsp[(2) - (2)].str);
    }
    break;

  case 109:
/* Line 1813 of yacc.c  */
#line 1260 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 110:
/* Line 1813 of yacc.c  */
#line 1267 "smtlib.y"
    {
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 111:
/* Line 1813 of yacc.c  */
#line 1276 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(1) - (1)].node);
    }
    break;

  case 112:
/* Line 1813 of yacc.c  */
#line 1280 "smtlib.y"
    {
      (yyval.node) = (yyvsp[(1) - (1)].node);
    }
    break;

  case 113:
/* Line 1813 of yacc.c  */
#line 1284 "smtlib.y"
    {
      if ((yyvsp[(1) - (1)].vec)->size() == 1) {
        (yyval.node) = new CVC3::Expr(((*(yyvsp[(1) - (1)].vec))[0]));
      }
      else {
        (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(1) - (1)].vec)));
      }
      delete (yyvsp[(1) - (1)].vec);
    }
    break;

  case 114:
/* Line 1813 of yacc.c  */
#line 1294 "smtlib.y"
    {
      (yyvsp[(4) - (8)].vec)->insert((yyvsp[(4) - (8)].vec)->end(), (yyvsp[(5) - (8)].vec)->begin(), (yyvsp[(5) - (8)].vec)->end());
      (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(4) - (8)].vec)));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_NOT", *(yyval.node)));
      delete (yyvsp[(4) - (8)].vec);
      delete (yyvsp[(5) - (8)].vec);
      delete (yyvsp[(6) - (8)].vec);
    }
    break;

  case 115:
/* Line 1813 of yacc.c  */
#line 1303 "smtlib.y"
    {
      (yyvsp[(4) - (7)].vec)->insert((yyvsp[(4) - (7)].vec)->end(), (yyvsp[(5) - (7)].vec)->begin(), (yyvsp[(5) - (7)].vec)->end());
      (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(4) - (7)].vec)));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_NOT", *(yyval.node)));
      delete (yyvsp[(4) - (7)].vec);
      delete (yyvsp[(5) - (7)].vec);
    }
    break;

  case 116:
/* Line 1813 of yacc.c  */
#line 1311 "smtlib.y"
    {
      (yyvsp[(2) - (5)].vec)->insert((yyvsp[(2) - (5)].vec)->end(), (yyvsp[(3) - (5)].vec)->begin(), (yyvsp[(3) - (5)].vec)->end());
      (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (5)].vec)));
      delete (yyvsp[(2) - (5)].vec);
      delete (yyvsp[(3) - (5)].vec);
      delete (yyvsp[(4) - (5)].vec);
    }
    break;

  case 117:
/* Line 1813 of yacc.c  */
#line 1319 "smtlib.y"
    {
      (yyvsp[(2) - (4)].vec)->insert((yyvsp[(2) - (4)].vec)->end(), (yyvsp[(3) - (4)].vec)->begin(), (yyvsp[(3) - (4)].vec)->end());
      (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (4)].vec)));
      delete (yyvsp[(2) - (4)].vec);
      delete (yyvsp[(3) - (4)].vec);
    }
    break;

  case 118:
/* Line 1813 of yacc.c  */
#line 1326 "smtlib.y"
    {
      CVC3::Expr e(VC->listExpr(VC->listExpr(*(yyvsp[(4) - (9)].node), *(yyvsp[(5) - (9)].node))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(7) - (9)].node)));
      delete (yyvsp[(4) - (9)].node);
      delete (yyvsp[(5) - (9)].node);
      delete (yyvsp[(7) - (9)].node);
      delete (yyvsp[(8) - (9)].vec);
    }
    break;

  case 119:
/* Line 1813 of yacc.c  */
#line 1335 "smtlib.y"
    {
      CVC3::Expr e(VC->listExpr(VC->listExpr(*(yyvsp[(4) - (8)].node), *(yyvsp[(5) - (8)].node))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(7) - (8)].node)));
      delete (yyvsp[(4) - (8)].node);
      delete (yyvsp[(5) - (8)].node);
      delete (yyvsp[(7) - (8)].node);
    }
    break;

  case 120:
/* Line 1813 of yacc.c  */
#line 1343 "smtlib.y"
    {
      CVC3::Expr e(VC->listExpr(VC->listExpr(*(yyvsp[(4) - (9)].node), *(yyvsp[(5) - (9)].node))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(7) - (9)].node)));
      delete (yyvsp[(4) - (9)].node);
      delete (yyvsp[(5) - (9)].node);
      delete (yyvsp[(7) - (9)].node);
      delete (yyvsp[(8) - (9)].vec);
    }
    break;

  case 121:
/* Line 1813 of yacc.c  */
#line 1352 "smtlib.y"
    {
      CVC3::Expr e(VC->listExpr(VC->listExpr(*(yyvsp[(4) - (8)].node), *(yyvsp[(5) - (8)].node))));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(7) - (8)].node)));
      delete (yyvsp[(4) - (8)].node);
      delete (yyvsp[(5) - (8)].node);
      delete (yyvsp[(7) - (8)].node);
    }
    break;

  case 122:
/* Line 1813 of yacc.c  */
#line 1363 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      if (BVENABLED && *(yyvsp[(1) - (4)].str) == "repeat") {
        (yyval.vec)->push_back(VC->idExpr("_BVREPEAT"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (4)].str) == "zero_extend") {
        (yyval.vec)->push_back(VC->idExpr("_BVZEROEXTEND"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (4)].str) == "sign_extend") {
        (yyval.vec)->push_back(VC->idExpr("_SX"));
        (yyval.vec)->push_back(VC->idExpr("_smtlib"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (4)].str) == "rotate_left") {
        (yyval.vec)->push_back(VC->idExpr("_BVROTL"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (4)].str) == "rotate_right") {
        (yyval.vec)->push_back(VC->idExpr("_BVROTR"));
      }
      else if (BVENABLED &&
               (yyvsp[(1) - (4)].str)->size() > 2 &&
               (*(yyvsp[(1) - (4)].str))[0] == 'b' &&
               (*(yyvsp[(1) - (4)].str))[1] == 'v') {
        int i = 2;
        while ((*(yyvsp[(1) - (4)].str))[i] >= '0' && (*(yyvsp[(1) - (4)].str))[i] <= '9') ++i;
        if ((*(yyvsp[(1) - (4)].str))[i] == '\0') {
          (yyval.vec)->push_back(VC->idExpr("_BVCONST"));
          (yyval.vec)->push_back(VC->ratExpr((yyvsp[(1) - (4)].str)->substr(2), 10));
        }
        else (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (4)].str)));
      }
      else (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (4)].str)));
      (yyval.vec)->push_back(VC->ratExpr(*(yyvsp[(3) - (4)].str)));
      delete (yyvsp[(1) - (4)].str);
      delete (yyvsp[(3) - (4)].str);
    }
    break;

  case 123:
/* Line 1813 of yacc.c  */
#line 1399 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      if (BVENABLED && *(yyvsp[(1) - (6)].str) == "extract") {
        (yyval.vec)->push_back(VC->idExpr("_EXTRACT"));
      }
      else (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (6)].str)));
      (yyval.vec)->push_back(VC->ratExpr(*(yyvsp[(3) - (6)].str)));
      (yyval.vec)->push_back(VC->ratExpr(*(yyvsp[(5) - (6)].str)));
      delete (yyvsp[(1) - (6)].str);
      delete (yyvsp[(3) - (6)].str);
      delete (yyvsp[(5) - (6)].str);
    }
    break;

  case 124:
/* Line 1813 of yacc.c  */
#line 1412 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      if (ARRAYSENABLED && *(yyvsp[(1) - (1)].str) == "select") {
        (yyval.vec)->push_back(VC->idExpr("_READ"));
      }
      else if (ARRAYSENABLED && *(yyvsp[(1) - (1)].str) == "store") {
        (yyval.vec)->push_back(VC->idExpr("_WRITE"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bit0") {
        (yyval.vec)->push_back(VC->idExpr("_BVCONST"));
        (yyval.vec)->push_back(VC->ratExpr(0));
        (yyval.vec)->push_back(VC->ratExpr(1));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bit1") {
        (yyval.vec)->push_back(VC->idExpr("_BVCONST"));
        (yyval.vec)->push_back(VC->ratExpr(1));
        (yyval.vec)->push_back(VC->ratExpr(1));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "concat") {
        (yyval.vec)->push_back(VC->idExpr("_CONCAT"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvnot") {
        (yyval.vec)->push_back(VC->idExpr("_BVNEG"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvand") {
        (yyval.vec)->push_back(VC->idExpr("_BVAND"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvor") {
        (yyval.vec)->push_back(VC->idExpr("_BVOR"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvneg") {
        (yyval.vec)->push_back(VC->idExpr("_BVUMINUS"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvadd") {
        (yyval.vec)->push_back(VC->idExpr("_BVPLUS"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvmul") {
        (yyval.vec)->push_back(VC->idExpr("_BVMULT"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvudiv") {
        (yyval.vec)->push_back(VC->idExpr("_BVUDIV"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvurem") {
        (yyval.vec)->push_back(VC->idExpr("_BVUREM"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvshl") {
        (yyval.vec)->push_back(VC->idExpr("_BVSHL"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvlshr") {
        (yyval.vec)->push_back(VC->idExpr("_BVLSHR"));
      }

      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvnand") {
        (yyval.vec)->push_back(VC->idExpr("_BVNAND"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvnor") {
        (yyval.vec)->push_back(VC->idExpr("_BVNOR"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvxor") {
        (yyval.vec)->push_back(VC->idExpr("_BVXOR"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvxnor") {
        (yyval.vec)->push_back(VC->idExpr("_BVXNOR"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvcomp") {
        (yyval.vec)->push_back(VC->idExpr("_BVCOMP"));
      }

      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvsub") {
        (yyval.vec)->push_back(VC->idExpr("_BVSUB"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvsdiv") {
        (yyval.vec)->push_back(VC->idExpr("_BVSDIV"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvsrem") {
        (yyval.vec)->push_back(VC->idExpr("_BVSREM"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvsmod") {
        (yyval.vec)->push_back(VC->idExpr("_BVSMOD"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvashr") {
        (yyval.vec)->push_back(VC->idExpr("_BVASHR"));
      }

      // predicates
      else if (BVENABLED && (*(yyvsp[(1) - (1)].str) == "bvlt" || *(yyvsp[(1) - (1)].str) == "bvult")) {
        (yyval.vec)->push_back(VC->idExpr("_BVLT"));
      }
      else if (BVENABLED && (*(yyvsp[(1) - (1)].str) == "bvleq" || *(yyvsp[(1) - (1)].str) == "bvule")) {
        (yyval.vec)->push_back(VC->idExpr("_BVLE"));
      }
      else if (BVENABLED && (*(yyvsp[(1) - (1)].str) == "bvgeq" || *(yyvsp[(1) - (1)].str) == "bvuge")) {
        (yyval.vec)->push_back(VC->idExpr("_BVGE"));
      }
      else if (BVENABLED && (*(yyvsp[(1) - (1)].str) == "bvgt" || *(yyvsp[(1) - (1)].str) == "bvugt")) {
        (yyval.vec)->push_back(VC->idExpr("_BVGT"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvslt") {
        (yyval.vec)->push_back(VC->idExpr("_BVSLT"));
      }
      else if (BVENABLED && (*(yyvsp[(1) - (1)].str) == "bvsleq" || *(yyvsp[(1) - (1)].str) == "bvsle")) {
        (yyval.vec)->push_back(VC->idExpr("_BVSLE"));
      }
      else if (BVENABLED && (*(yyvsp[(1) - (1)].str) == "bvsgeq" || *(yyvsp[(1) - (1)].str) == "bvsge")) {
        (yyval.vec)->push_back(VC->idExpr("_BVSGE"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "bvsgt") {
        (yyval.vec)->push_back(VC->idExpr("_BVSGT"));
      }
      else if (*(yyvsp[(1) - (1)].str) == "IsInt") {
        (yyval.vec)->push_back(VC->idExpr("_IS_INTEGER"));
      }

      // For backwards compatibility:
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "shift_left0") {
        (yyval.vec)->push_back(VC->idExpr("_CONST_WIDTH_LEFTSHIFT"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "shift_right0") {
        (yyval.vec)->push_back(VC->idExpr("_RIGHTSHIFT"));
      }
      else if (BVENABLED && *(yyvsp[(1) - (1)].str) == "sign_extend") {
        (yyval.vec)->push_back(VC->idExpr("_SX"));
        (yyval.vec)->push_back(VC->idExpr("_smtlib"));
      }

      // Bitvector constants
      else if (BVENABLED &&
               (yyvsp[(1) - (1)].str)->size() > 2 &&
               (*(yyvsp[(1) - (1)].str))[0] == 'b' &&
               (*(yyvsp[(1) - (1)].str))[1] == 'v') {
        bool done = false;
        if ((*(yyvsp[(1) - (1)].str))[2] >= '0' && (*(yyvsp[(1) - (1)].str))[2] <= '9') {
          int i = 3;
          while ((*(yyvsp[(1) - (1)].str))[i] >= '0' && (*(yyvsp[(1) - (1)].str))[i] <= '9') ++i;
          if ((*(yyvsp[(1) - (1)].str))[i] == '\0') {
            (yyval.vec)->push_back(VC->idExpr("_BVCONST"));
            (yyval.vec)->push_back(VC->ratExpr((yyvsp[(1) - (1)].str)->substr(2), 10));
            (yyval.vec)->push_back(VC->ratExpr(32));
            done = true;
          }
        }
        else if ((yyvsp[(1) - (1)].str)->size() > 5) {
          std::string s = (yyvsp[(1) - (1)].str)->substr(0,5);
          if (s == "bvbin") {
            int i = 5;
            while ((*(yyvsp[(1) - (1)].str))[i] >= '0' && (*(yyvsp[(1) - (1)].str))[i] <= '1') ++i;
            if ((*(yyvsp[(1) - (1)].str))[i] == '\0') {
              (yyval.vec)->push_back(VC->idExpr("_BVCONST"));
              (yyval.vec)->push_back(VC->ratExpr((yyvsp[(1) - (1)].str)->substr(5), 2));
              (yyval.vec)->push_back(VC->ratExpr(i-5));
              done = true;
            }
          }
          else if (s == "bvhex") {
            int i = 5;
            char c = (*(yyvsp[(1) - (1)].str))[i];
            while ((c >= '0' && c <= '9') ||
                   (c >= 'a' && c <= 'f') ||
                   (c >= 'A' && c <= 'F')) {
              ++i;
              c =(*(yyvsp[(1) - (1)].str))[i];
            }
            if ((*(yyvsp[(1) - (1)].str))[i] == '\0') {
              (yyval.vec)->push_back(VC->idExpr("_BVCONST"));
              (yyval.vec)->push_back(VC->ratExpr((yyvsp[(1) - (1)].str)->substr(5), 16));
              (yyval.vec)->push_back(VC->ratExpr(i-5));
              done = true;
            }
          }
        }
        if (!done) (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (1)].str)));
      }
      else {
        (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (1)].str)));
      }
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 125:
/* Line 1813 of yacc.c  */
#line 1590 "smtlib.y"
    { 
      (yyval.vec) = new std::vector<CVC3::Expr>;
      if ((yyvsp[(1) - (1)].str)->length() == 1) {
	switch ((*(yyvsp[(1) - (1)].str))[0]) {
	case '+': (yyval.vec)->push_back(VC->idExpr("_PLUS")); break;
	case '-': (yyval.vec)->push_back(VC->idExpr("_MINUS")); break;
	case '*': (yyval.vec)->push_back(VC->idExpr("_MULT")); break;
	case '~': (yyval.vec)->push_back(VC->idExpr("_UMINUS")); break;
	case '/': (yyval.vec)->push_back(VC->idExpr("_DIVIDE")); break;
        case '=': (yyval.vec)->push_back(VC->idExpr("_EQ")); break;
        case '<': (yyval.vec)->push_back(VC->idExpr("_LT")); break;
        case '>': (yyval.vec)->push_back(VC->idExpr("_GT")); break;
	default: (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (1)].str)));
	}
      }
      else {
	if (*(yyvsp[(1) - (1)].str) == "<=") {
	  (yyval.vec)->push_back(VC->idExpr("_LE"));
	} else if (*(yyvsp[(1) - (1)].str) == ">=") {
	  (yyval.vec)->push_back(VC->idExpr("_GE"));
	}
	else (yyval.vec)->push_back(VC->idExpr(*(yyvsp[(1) - (1)].str)));
      }
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 126:
/* Line 1813 of yacc.c  */
#line 1616 "smtlib.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      CVC3::Expr e = VC->ratExpr(*(yyvsp[(1) - (1)].str));
      if(VC->getFlags()["translate"].getBool() && (yyvsp[(1) - (1)].str)->find('.') != std::string::npos) {
        e = CVC3::Expr(CVC3::REAL_CONST, e);
      }
      (yyval.vec)->push_back(e);
      delete (yyvsp[(1) - (1)].str);
    }
    break;


/* Line 1813 of yacc.c  */
#line 3680 "parsesmtlib.cpp"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2076 of yacc.c  */
#line 1629 "smtlib.y"

